<template>
  <input-base :name="name" :size="size" :error="error" :styled="false">
    <div
      :class="['radio-element', { selected: element.id == modelValue }]"
      v-for="element in list"
      :key="element.id"
    >
      <input
        type="radio"
        :id="`${randomHash}-${element.id}`"
        :name="randomHash"
        :value="element.id"
        v-on:input.stop="select($event, element)"
      />
      <label :for="`${randomHash}-${element.id}`">{{
        element.display_name
      }}</label>
    </div>
  </input-base>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import InputBase from "@/components/input/InputBase.vue";

import { InputListItem } from "@/interfaces";

@Options({
  props: {
    modelValue: {
      type: String,
      requierd: true,
    },
    list: {
      type: Array,
      requierd: true,
    },
    size: {
      type: String,
      requierd: false,
    },
    name: {
      type: String,
      requierd: false,
    },
    error: {
      type: String,
      requierd: false,
    },
  },
  emits: ["update:modelValue"],
  components: {
    InputBase,
  },
})
export default class InputRadio extends Vue {
  public modelValue!: string;
  public list!: InputListItem[];

  public size?: string;
  public name?: string;
  public error?: string;

  public randomHash = "";

  public mounted(): void {
    this.randomHash = String(Math.random());
  }

  public select(event: any, element: InputListItem): void {
    if (event.target.value) {
      this.$emit("update:modelValue", element.id);
    }
  }
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";
.radio-element {
  box-shadow: 0 0 3px 0 $shadow_grey;
  box-sizing: border-box;
  padding: 10px;
  color: $black_text;
  margin-right: $small_spacing;
  position: relative;

  input {
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0px;
    right: 0px;
    margin: 0;

    opacity: 0;

    cursor: pointer;
  }

  background-color: $white_bg;

  &.selected {
    background-color: $dark_blue;
    color: $white_bg;
  }
}
</style>
